osl::rating::AttackKing8 Class Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Static Private Member Functions | Private Attributes | List of all members
osl::rating::AttackKing8 Class Reference

`#include <king8.h>`

Inheritance diagram for osl::rating::AttackKing8:
[legend]
Collaboration diagram for osl::rating::AttackKing8:
[legend]

## Public Member Functions
| AttackKing8 (Ptype s, Ptype t, bool ss, int attack, int defense)
bool | match (const NumEffectState &state, Move move, const RatingEnv &env) const
Public Member Functions inherited from osl::rating::Feature
| Feature (const std::string &name)
virtual | ~Feature ()
virtual bool | effectiveInCheck () const
const std::string & | name () const

## Static Private Member Functions
static const std::string | name (Ptype self, Ptype target, bool same)
Static Private Member Functions inherited from osl::rating::CountEffect2
static std::pair< int, int > | count (const NumEffectState &state, Square position, const RatingEnv &env)
static std::string | name (int attack, int defense)
static int | index (const NumEffectState &state, Square position, const RatingEnv &env)

## Private Attributes
Ptype | self
Ptype | target
bool | same
Private Attributes inherited from osl::rating::CountEffect2
int | attack
int | defense

## Additional Inherited Members
Private Member Functions inherited from osl::rating::CountEffect2
| CountEffect2 (int a, int d)
bool | match (const NumEffectState &state, Square position, const RatingEnv &env) const
Static Private Attributes inherited from osl::rating::CountEffect2
static const int | Max = 2

## Detailed Description

Definition at line 15 of file rating/feature/king8.h.

## Constructor & Destructor Documentation

osl::rating::AttackKing8::AttackKing8 | ( | Ptype | s,
|  | Ptype | t,
|  | bool | ss,
|  | int | attack,
|  | int | defense
| ) |  |
| inline

Definition at line 21 of file rating/feature/king8.h.

## Member Function Documentation

bool osl::rating::AttackKing8::match | ( | const NumEffectState & | state,
|  | Move | move,
|  | const RatingEnv & | env
| ) |  | const
| inlinevirtual

Implements osl::rating::Feature.

Definition at line 26 of file rating/feature/king8.h.

References osl::alt(), osl::Move::from(), osl::Move::isDrop(), osl::isPiece(), osl::Square::isPieceStand(), osl::rating::CountEffect2::match(), osl::Piece::owner(), osl::Move::player(), osl::Piece::ptype(), osl::Move::ptype(), osl::Move::ptypeO(), same, target, and osl::Move::to().

const std::string osl::rating::AttackKing8::name | ( | Ptype | self,
|  | Ptype | target,
|  | bool | same
| ) |  |
| staticprivate

Definition at line 5 of file rating/feature/king8.cc.

References osl::PtypeTable::getCsaName(), and osl::Ptype_Table.

## Member Data Documentation

bool osl::rating::AttackKing8::same
| private

Definition at line 18 of file rating/feature/king8.h.

Referenced by match().

Ptype osl::rating::AttackKing8::self
| private

Definition at line 17 of file rating/feature/king8.h.

Ptype osl::rating::AttackKing8::target
| private

Definition at line 17 of file rating/feature/king8.h.

Referenced by match().

The documentation for this class was generated from the following files:

- rating/feature/king8.h
- rating/feature/king8.cc